]> git.saurik.com Git - apt.git/blame - test/integration/framework
don't drop privileges if _apt has not enough rights
[apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
5d76cee1 3EXIT_CODE=0
8c1dd12c 4
8d876415 5# we all like colorful messages
1290422a 6if [ "$MSGCOLOR" != 'NO' ]; then
27cb4f6c 7 if [ ! -t 1 ]; then # but check that we output to a terminal
1290422a
DK
8 export MSGCOLOR='NO'
9 fi
10fi
11
12
13if [ "$MSGCOLOR" != 'NO' ]; then
14 CERROR="\033[1;31m" # red
15 CWARNING="\033[1;33m" # yellow
16 CMSG="\033[1;32m" # green
17 CINFO="\033[1;96m" # light blue
18 CDEBUG="\033[1;94m" # blue
19 CNORMAL="\033[0;39m" # default system console color
20 CDONE="\033[1;32m" # green
21 CPASS="\033[1;32m" # green
22 CFAIL="\033[1;31m" # red
23 CCMD="\033[1;35m" # pink
682a3bf7 24fi
8d876415 25
3c528b91
MO
26msgdie() { printf "${CERROR}E: $1${CNORMAL}\n" >&2; exit 1; }
27msgwarn() { printf "${CWARNING}W: $1${CNORMAL}\n" >&2; }
28msgmsg() { printf "${CMSG}$1${CNORMAL}\n"; }
29msginfo() { printf "${CINFO}I: $1${CNORMAL}\n"; }
30msgdebug() { printf "${CDEBUG}D: $1${CNORMAL}\n"; }
31msgdone() { printf "${CDONE}DONE${CNORMAL}\n"; }
32msgnwarn() { printf "${CWARNING}W: $1${CNORMAL}" >&2; }
33msgnmsg() { printf "${CMSG}$1${CNORMAL}"; }
34msgninfo() { printf "${CINFO}I: $1${CNORMAL}"; }
35msgndebug() { printf "${CDEBUG}D: $1${CNORMAL}"; }
2a2a7ef4
DK
36msgtest() {
37 while [ -n "$1" ]; do
3c528b91
MO
38 printf "${CINFO}$1${CCMD} "
39 printf -- "$(echo "$2" | sed -e 's#^apt\([cgfs]\)#apt-\1#')${CINFO} "
d73840dc
DK
40 shift
41 if [ -n "$1" ]; then shift; else break; fi
2a2a7ef4 42 done
3c528b91 43 printf "…${CNORMAL} "
2a2a7ef4 44}
3c528b91
MO
45msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
46msgskip() { printf "${CWARNING}SKIP${CNORMAL}\n" >&2; }
5229b285 47msgfail() {
3c528b91
MO
48 if [ $# -gt 0 ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
49 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
4d0818cc
MV
50 if [ -n "$APT_DEBUG_TESTS" ]; then
51 bash
52 fi
5229b285
DK
53 EXIT_CODE=$((EXIT_CODE+1));
54}
8d876415
DK
55
56# enable / disable Debugging
fc89263e
DK
57MSGLEVEL=${MSGLEVEL:-3}
58if [ $MSGLEVEL -le 0 ]; then
59 msgdie() { true; }
60fi
61if [ $MSGLEVEL -le 1 ]; then
62 msgwarn() { true; }
63 msgnwarn() { true; }
64fi
65if [ $MSGLEVEL -le 2 ]; then
66 msgmsg() { true; }
67 msgnmsg() { true; }
39cc8228 68 msgtest() { true; }
3c528b91
MO
69 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
70 msgskip() { printf " ${CWARNING}S${CNORMAL}" >&2; }
682a3bf7 71 if [ -n "$CFAIL" ]; then
3c528b91 72 msgfail() { printf " ${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE=$((EXIT_CODE+1)); }
682a3bf7 73 else
3c528b91 74 msgfail() { printf " ###FAILED###" >&2; EXIT_CODE=$((EXIT_CODE+1)); }
682a3bf7 75 fi
fc89263e
DK
76fi
77if [ $MSGLEVEL -le 3 ]; then
78 msginfo() { true; }
79 msgninfo() { true; }
80fi
81if [ $MSGLEVEL -le 4 ]; then
82 msgdebug() { true; }
83 msgndebug() { true; }
84fi
85msgdone() {
86 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
87 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
88 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
89 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
90 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
91 true;
92 else
3c528b91 93 printf "${CDONE}DONE${CNORMAL}\n";
fc89263e
DK
94 fi
95}
e43a426e
MV
96getaptconfig() {
97 if [ -f ./aptconfig.conf ]; then
98 echo "./aptconfig.conf"
99 elif [ -f ../aptconfig.conf ]; then
100 echo "../aptconfig.conf"
101 fi
102}
8d876415
DK
103runapt() {
104 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
846856f4
DK
105 local CMD="$1"
106 shift
3b8eb3bc 107 case $CMD in
a311fb96 108 sh|aptitude|*/*|command) ;;
3b8eb3bc
DK
109 *) CMD="${BUILDDIRECTORY}/$CMD";;
110 esac
a311fb96 111 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${LIBRARYPATH} $CMD "$@"
8d876415 112}
846856f4
DK
113aptconfig() { runapt apt-config "$@"; }
114aptcache() { runapt apt-cache "$@"; }
115aptcdrom() { runapt apt-cdrom "$@"; }
116aptget() { runapt apt-get "$@"; }
117aptftparchive() { runapt apt-ftparchive "$@"; }
118aptkey() { runapt apt-key "$@"; }
119aptmark() { runapt apt-mark "$@"; }
4f6d26b4 120aptsortpkgs() { runapt apt-sortpkgs "$@"; }
796673c3 121apt() { runapt apt "$@"; }
3b8eb3bc
DK
122apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
123aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
124aptitude() { runapt aptitude "$@"; }
8d50b63f 125aptextracttemplates() { runapt apt-extracttemplates "$@"; }
3082603f 126aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
3b8eb3bc 127
158fda31 128dpkg() {
846856f4 129 command dpkg --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log "$@"
158fda31 130}
ce7f128c
DK
131dpkgcheckbuilddeps() {
132 command dpkg-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg "$@"
b6b5a542 133}
3fa950f1 134gdb() {
a311fb96 135 local CMD="$1"
ce928105 136 shift
a311fb96 137 runapt command gdb --quiet -ex run "${BUILDDIRECTORY}/$CMD" --args "${BUILDDIRECTORY}/$CMD" "$@"
ae99ce2e 138}
8d876415 139
8c1dd12c 140exitwithstatus() {
f91bd741
MV
141 # error if we about to overflow, but ...
142 # "255 failures ought to be enough for everybody"
5d76cee1
MV
143 if [ $EXIT_CODE -gt 255 ]; then
144 msgdie "Total failure count $EXIT_CODE too big"
f91bd741 145 fi
5d76cee1 146 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
8c1dd12c
MV
147}
148
804d4a0d
DK
149shellsetedetector() {
150 local exit_status=$?
151 if [ "$exit_status" != '0' ]; then
3c528b91 152 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
804d4a0d
DK
153 if [ "$EXIT_CODE" = '0' ]; then
154 EXIT_CODE="$exit_status"
155 fi
156 fi
157}
158
b720d0bd 159addtrap() {
8437b7d4
DK
160 if [ "$1" = 'prefix' ]; then
161 CURRENTTRAP="$2 $CURRENTTRAP"
162 else
163 CURRENTTRAP="$CURRENTTRAP $1"
164 fi
804d4a0d 165 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
b720d0bd 166}
8d876415
DK
167
168setupenvironment() {
75954ae2 169 TMPWORKINGDIRECTORY=$(mktemp -d)
5684f71f 170 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;"
3cbbda3c 171 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
5c0dd6fc 172
5684f71f 173 TESTDIRECTORY=$(readlink -f $(dirname $0))
5c0dd6fc
MV
174 # allow overriding the default BUILDDIR location
175 BUILDDIRECTORY=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
3b8eb3bc 176 LIBRARYPATH=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}
5c0dd6fc 177 METHODSDIR=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
e43a426e 178 APTHELPERBINDIR=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}
c035b655 179 APTWEBSERVERBINDIR=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
3082603f 180 APTINTERNALSOLVER=${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}
8d876415 181 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
5c0dd6fc
MV
182 # -----
183
8d876415 184 cd $TMPWORKINGDIRECTORY
cd725954 185 mkdir rootdir aptarchive keys
8d876415 186 cd rootdir
b29c3712 187 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
33677a0c 188 mkdir -p var/cache var/lib/apt var/log tmp
cffea9af 189 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
cd725954 190 touch var/lib/dpkg/available
8d876415 191 mkdir -p usr/lib/apt
9082a1fc 192 ln -s ${METHODSDIR} usr/lib/apt/methods
1f6cf9e7
DK
193 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
194 mkdir -p usr/lib/apt/solvers
195 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
196 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
197 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
198 fi
291a386f
MV
199 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
200 # system
201 if [ -e ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove ]; then
202 ln -s ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove etc/apt/apt.conf.d/01autoremove
203 else
204 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
205 fi
8d876415 206 cd ..
2c6baa5a 207 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
53ea1b56
DK
208 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
209 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 210 fi
4a4ea26c 211 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
53ea1b56
DK
212 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
213 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 214 fi
53ea1b56 215 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
5684f71f 216 chmod 644 $(find keys -name '*.pub' -o -name '*.sec')
cd725954 217 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
d6cf2345 218
cffea9af 219 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 220 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
221 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
222 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
5c0dd6fc 223 echo "Dir::Bin::Methods \"${METHODSDIR}\";" >> aptconfig.conf
12841e83 224 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
cffea9af
DK
225 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
226 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
227 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
228 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
229 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
846856f4 230 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
53ea1b56
DK
231 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
232 fi
cffea9af 233 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 234 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
0c8171d7 235 echo 'quiet::NoStatistic "true";' >> aptconfig.conf
d6cf2345
DK
236 # too distracting for users, but helpful to detect changes
237 echo 'Acquire::Progress::Ignore::ShowErrorText "true";' >> aptconfig.conf
0045df3f
DK
238 # in testcases, it can appear as if localhost has a rotation setup,
239 # hide this as we can't really deal with it properly
240 echo 'Acquire::Failure::ShowIP "false";' >> aptconfig.conf
d6cf2345 241
23af9f40 242 echo "Acquire::https::CaInfo \"${TESTDIR}/apt.pem\";" > rootdir/etc/apt/apt.conf.d/99https
d6cf2345 243 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
276e51dd 244 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
77a45beb 245
d4f4bcf7
MV
246 # Acquire::AllowInsecureRepositories=false is not yet the default
247 # but we want it to be the default soon
248 configallowinsecurerepositories "false";
249
ce7f128c 250 # cleanup the environment a bit
8c617819
MV
251 # prefer our apt binaries over the system apt binaries
252 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
be233796 253 export LC_ALL=C.UTF-8
3b8eb3bc 254 unset LANGUAGE APT_CONFIG
ce7f128c
DK
255 unset GREP_OPTIONS DEB_BUILD_PROFILES
256
8d876415
DK
257 msgdone "info"
258}
259
ea65d079
DK
260getarchitecture() {
261 if [ "$1" = "native" -o -z "$1" ]; then
262 eval `aptconfig shell ARCH APT::Architecture`
263 if [ -n "$ARCH" ]; then
264 echo $ARCH
265 else
5834d7a1 266 dpkg --print-architecture
ea65d079
DK
267 fi
268 else
269 echo $1
270 fi
271}
272
53ea1b56
DK
273getarchitectures() {
274 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
275}
276
3dcdc1f9
DK
277getarchitecturesfromcommalist() {
278 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
279}
280
8d876415 281configarchitecture() {
18908589
DK
282 {
283 echo "APT::Architecture \"$(getarchitecture $1)\";"
284 while [ -n "$1" ]; do
285 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
286 shift
287 done
288 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
53ea1b56
DK
289 configdpkg
290}
291
292configdpkg() {
293 if [ ! -e rootdir/var/lib/dpkg/status ]; then
294 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
295 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
296 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
297 else
298 echo -n > rootdir/var/lib/dpkg/status
299 fi
300 fi
18908589 301 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
846856f4 302 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
53ea1b56
DK
303 local ARCHS="$(getarchitectures)"
304 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
305 DPKGARCH="$(dpkg --print-architecture)"
306 for ARCH in ${ARCHS}; do
feae193b 307 if [ "${ARCH}" != "${DPKGARCH}" ]; then
18908589 308 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
feae193b 309 # old-style used e.g. in Ubuntu-P – and as it seems travis
18908589
DK
310 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
311 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
feae193b
DK
312 fi
313 fi
53ea1b56
DK
314 done
315 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
05343a22
DK
316 # dpkg doesn't really check the version as long as it is fully installed,
317 # but just to be sure we choose one above the required version
318 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
53ea1b56
DK
319 fi
320 fi
321 fi
8d876415
DK
322}
323
d4f4bcf7
MV
324configallowinsecurerepositories() {
325 echo "Acquire::AllowInsecureRepositories \"$1\";" > rootdir/etc/apt/apt.conf.d/allow-insecure-repositories.conf
326
327}
328
276e51dd
DK
329configcompression() {
330 while [ -n "$1" ]; do
331 case "$1" in
3c528b91
MO
332 '.') printf ".\t.\tcat\n";;
333 'gz') printf "gzip\tgz\tgzip\n";;
334 'bz2') printf "bzip2\tbz2\tbzip2\n";;
335 'lzma') printf "lzma\tlzma\txz --format=lzma\n";;
336 'xz') printf "xz\txz\txz\n";;
337 *) printf "$1\t$1\t$1\n";;
276e51dd
DK
338 esac
339 shift
340 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
341}
342
5f982b9d
DK
343forcecompressor() {
344 COMPRESSOR="$1"
345 COMPRESSOR_CMD="$1"
346 case $COMPRESSOR in
347 gzip) COMPRESS='gz';;
348 bzip2) COMPRESS='bz2';;
349 lzma) COMPRESS='lzma';;
350 xz) COMPRESS='xz';;
351 *) msgdie "Compressor $COMPRESSOR is unknown to framework, so can't be forced by forcecompressor!";;
352 esac
353 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
354 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
355Dir::Bin::uncompressed \"/does/not/exist\";
356Dir::Bin::gzip \"/does/not/exist\";
357Dir::Bin::bzip2 \"/does/not/exist\";
358Dir::Bin::lzma \"/does/not/exist\";
359Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE"
360 if [ -e "/bin/${COMPRESSOR}" ]; then
361 echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE"
362 elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
363 echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE"
364 elif [ "${COMPRESSOR}" = 'lzma' ]; then
365 echo 'Dir::Bin::xz "/usr/bin/xz";' >> "$CONFFILE"
366 COMPRESSOR_CMD='xz --format=lzma'
367 else
368 msgtest 'Test for availability of compressor' "${COMPRESSOR}"
369 msgfail
370 fi
371}
372
75954ae2 373setupsimplenativepackage() {
ce9864a8
DK
374 local NAME="$1"
375 local ARCH="$2"
376 local VERSION="$3"
377 local RELEASE="${4:-unstable}"
378 local DEPENDENCIES="$5"
14109555 379 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
380 If you find such a package installed on your system,
381 something went horribly wrong! They are autogenerated
382 und used only by testcases and surf no other propose…"}"
383
b7899b00
DK
384 local SECTION="${7:-others}"
385 local DISTSECTION
386 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
387 DISTSECTION="main"
388 else
389 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
390 fi
ce9864a8
DK
391 local BUILDDIR=incoming/${NAME}-${VERSION}
392 mkdir -p ${BUILDDIR}/debian/source
393 cd ${BUILDDIR}
394 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
395 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
396 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
397
398 * Initial release
399
b7899b00
DK
400 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
401 test -e debian/control || echo "Source: $NAME
402Section: $SECTION
ce9864a8
DK
403Priority: optional
404Maintainer: Joe Sixpack <joe@example.org>
405Build-Depends: debhelper (>= 7)
406Standards-Version: 3.9.1
407
875bcb36
DK
408Package: $NAME" > debian/control
409 if [ "$ARCH" = 'all' ]; then
410 echo "Architecture: all" >> debian/control
411 else
412 echo "Architecture: any" >> debian/control
413 fi
ce9864a8 414 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
18908589
DK
415 echo "Description: $DESCRIPTION" >> debian/control
416
b7899b00
DK
417 test -e debian/compat || echo "7" > debian/compat
418 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 419 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
420 cd - > /dev/null
421}
422
423buildsimplenativepackage() {
424 local NAME="$1"
425 local ARCH="$2"
426 local VERSION="$3"
427 local RELEASE="${4:-unstable}"
428 local DEPENDENCIES="$5"
14109555 429 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
430 If you find such a package installed on your system,
431 something went horribly wrong! They are autogenerated
432 und used only by testcases and surf no other propose…"}"
433
75954ae2 434 local SECTION="${7:-others}"
d67004e0 435 local PRIORITY="${8:-optional}"
42c1513b 436 local FILE_TREE="$9"
adff049d 437 local COMPRESS_TYPE="${10:-gzip}"
75954ae2
DK
438 local DISTSECTION
439 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
440 DISTSECTION="main"
441 else
442 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
443 fi
5a635ee4 444 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 445
18331adf 446 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
447 mkdir -p $BUILDDIR/debian/source
448 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
449 echo "#!/bin/sh
450echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
451
452 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
453 echo "$NAME ($VERSION) $RELEASE; urgency=low
454
455 * Initial release
456
457 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
458 echo "Source: $NAME
459Section: $SECTION
d67004e0 460Priority: $PRIORITY
b761356f 461Maintainer: Joe Sixpack <joe@example.org>
01f520ce
DK
462Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
463 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
464 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
465 echo "
466Package: $NAME" >> ${BUILDDIR}/debian/control
b761356f 467
875bcb36
DK
468 if [ "$ARCH" = 'all' ]; then
469 echo "Architecture: all" >> ${BUILDDIR}/debian/control
470 else
471 echo "Architecture: any" >> ${BUILDDIR}/debian/control
472 fi
01f520ce
DK
473 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
474 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
18908589 475 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
01f520ce 476
b761356f 477 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
f1828b69
DK
478 (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \
479 | while read SRC; do
5a635ee4 480 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
f1828b69 481# if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
33a22672 482# aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
bd7fb5aa 483# adv --yes --default-key 'Joe Sixpack' \
f1828b69
DK
484# --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
485# mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
486# fi
b761356f 487 done
84aa13f4 488
3dcdc1f9 489 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
84aa13f4
DK
490 rm -rf ${BUILDDIR}/debian/tmp
491 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
492 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
493 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
42c1513b
MV
494 if [ -n "$FILE_TREE" ]; then
495 cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp
496 fi
42c1513b 497
84aa13f4
DK
498 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
499 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
846856f4 500 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
eb9dee96
DK
501 # ensure the right permissions as dpkg-deb ensists
502 chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN
adff049d 503 if ! dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. >$LOG 2>&1; then
846856f4
DK
504 cat $LOG
505 false
506 fi
507 rm $LOG
84aa13f4
DK
508 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
509 done
510
13845042
DK
511 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
512 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
513 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
5a635ee4 514 rm -rf "${BUILDDIR}"
b761356f 515 msgdone "info"
75954ae2
DK
516}
517
518buildpackage() {
519 local BUILDDIR=$1
520 local RELEASE=$2
521 local SECTION=$3
ea65d079 522 local ARCH=$(getarchitecture $4)
846856f4
DK
523 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
524 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
525 msgninfo "Build package ${PKGNAME} for ${RELEASE} in ${SECTION}… "
75954ae2
DK
526 cd $BUILDDIR
527 if [ "$ARCH" = "all" ]; then
528 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
529 fi
846856f4
DK
530 if ! dpkg-buildpackage -uc -us -a$ARCH >$BUILDLOG 2>&1 ; then
531 cat $BUILDLOG
532 false
533 fi
534 local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
535 local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 536 cd - > /dev/null
b7899b00 537 for PKG in $PKGS; do
75954ae2 538 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
539 done
540 for SRC in $SRCS; do
75954ae2 541 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 542 done
cffea9af 543 msgdone "info"
ce9864a8
DK
544}
545
546buildaptarchive() {
ce9864a8 547 if [ -d incoming ]; then
846856f4 548 buildaptarchivefromincoming "$@"
ce9864a8 549 else
846856f4 550 buildaptarchivefromfiles "$@"
ce9864a8
DK
551 fi
552}
553
554createaptftparchiveconfig() {
276e51dd
DK
555 local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
556 COMPRESSORS="${COMPRESSORS%* }"
ce9864a8 557 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
558 if [ -z "$ARCHS" ]; then
559 # the pool is empty, so we will operate on faked packages - let us use the configured archs
53ea1b56 560 ARCHS="$(getarchitectures)"
158fda31 561 fi
ce9864a8
DK
562 echo -n 'Dir {
563 ArchiveDir "' >> ftparchive.conf
564 echo -n $(readlink -f .) >> ftparchive.conf
565 echo -n '";
566 CacheDir "' >> ftparchive.conf
567 echo -n $(readlink -f ..) >> ftparchive.conf
568 echo -n '";
b7899b00
DK
569 FileListDir "' >> ftparchive.conf
570 echo -n $(readlink -f pool/) >> ftparchive.conf
571 echo -n '";
572};
573Default {
276e51dd
DK
574 Packages::Compress "'"$COMPRESSORS"'";
575 Sources::Compress "'"$COMPRESSORS"'";
576 Contents::Compress "'"$COMPRESSORS"'";
577 Translation::Compress "'"$COMPRESSORS"'";
18331adf 578 LongDescription "false";
ce9864a8
DK
579};
580TreeDefault {
581 Directory "pool/";
582 SrcDirectory "pool/";
583};
584APT {
585 FTPArchive {
586 Release {
587 Origin "joesixpack";
588 Label "apttestcases";
589 Suite "unstable";
590 Description "repository with dummy packages";
591 Architectures "' >> ftparchive.conf
592 echo -n "$ARCHS" >> ftparchive.conf
593 echo 'source";
594 };
595 };
596};' >> ftparchive.conf
b7899b00
DK
597 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
598 echo -n 'tree "dists/' >> ftparchive.conf
599 echo -n "$DIST" >> ftparchive.conf
600 echo -n '" {
ce9864a8
DK
601 Architectures "' >> ftparchive.conf
602 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
603 echo -n 'source";
604 FileList "' >> ftparchive.conf
605 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
606 echo -n '";
607 SourceFileList "' >> ftparchive.conf
608 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
609 echo -n '";
610 Sections "' >> ftparchive.conf
611 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
612 echo '";
ce9864a8 613};' >> ftparchive.conf
b7899b00 614 done
ce9864a8
DK
615}
616
617buildaptftparchivedirectorystructure() {
b7899b00
DK
618 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
619 for DIST in $DISTS; do
620 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
621 for SECTION in $SECTIONS; do
622 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
623 for ARCH in $ARCHS; do
624 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
625 done
626 mkdir -p dists/${DIST}/${SECTION}/source
627 mkdir -p dists/${DIST}/${SECTION}/i18n
628 done
ce9864a8 629 done
ce9864a8
DK
630}
631
9b78cda6
DK
632insertpackage() {
633 local RELEASE="$1"
634 local NAME="$2"
635 local ARCH="$3"
636 local VERSION="$4"
637 local DEPENDENCIES="$5"
d67004e0 638 local PRIORITY="${6:-optional}"
14109555 639 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
640 If you find such a package installed on your system,
641 something went horribly wrong! They are autogenerated
642 und used only by testcases and surf no other propose…"}"
d67004e0 643 local ARCHS=""
3dcdc1f9 644 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
c919ad6e 645 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
53ea1b56 646 ARCHS="$(getarchitectures)"
d67004e0
DK
647 else
648 ARCHS="$arch"
649 fi
650 for BUILDARCH in $ARCHS; do
651 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
652 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
653 touch aptarchive/dists/${RELEASE}/main/source/Sources
654 local FILE="${PPATH}/Packages"
655 echo "Package: $NAME
656Priority: $PRIORITY
9b78cda6 657Section: other
2c085486 658Installed-Size: 42
c919ad6e
DK
659Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
660 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
661 echo "Version: $VERSION
d67004e0
DK
662Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
663 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
18908589 664 echo "Description: $DESCRIPTION" >> $FILE
8ba17539 665 echo >> $FILE
d67004e0 666 done
9b78cda6
DK
667 done
668}
669
234675b7
DK
670insertsource() {
671 local RELEASE="$1"
672 local NAME="$2"
673 local ARCH="$3"
674 local VERSION="$4"
675 local DEPENDENCIES="$5"
676 local ARCHS=""
677 local SPATH="aptarchive/dists/${RELEASE}/main/source"
678 mkdir -p $SPATH
679 local FILE="${SPATH}/Sources"
680 echo "Package: $NAME
681Binary: $NAME
682Version: $VERSION
683Maintainer: Joe Sixpack <joe@example.org>
684Architecture: $ARCH" >> $FILE
685 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
686 echo "Files:
687 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
d5dea0be
DK
688 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
689" >> $FILE
234675b7
DK
690}
691
dfc2b1be
DK
692insertinstalledpackage() {
693 local NAME="$1"
694 local ARCH="$2"
695 local VERSION="$3"
696 local DEPENDENCIES="$4"
d67004e0 697 local PRIORITY="${5:-optional}"
d4b4e5ea 698 local STATUS="${6:-install ok installed}"
14109555 699 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
18908589
DK
700 If you find such a package installed on your system,
701 something went horribly wrong! They are autogenerated
702 und used only by testcases and surf no other propose…"}"
703
53ea1b56
DK
704 local FILE='rootdir/var/lib/dpkg/status'
705 local INFO='rootdir/var/lib/dpkg/info'
3dcdc1f9 706 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
d67004e0 707 echo "Package: $NAME
d4b4e5ea 708Status: $STATUS
d67004e0 709Priority: $PRIORITY
dfc2b1be
DK
710Section: other
711Installed-Size: 42
712Maintainer: Joe Sixpack <joe@example.org>
dfc2b1be 713Version: $VERSION" >> $FILE
c919ad6e 714 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
d67004e0 715 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
18908589
DK
716 echo "Description: $DESCRIPTION" >> $FILE
717 echo >> $FILE
53ea1b56
DK
718 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
719 echo -n > ${INFO}/${NAME}:${arch}.list
720 else
721 echo -n > ${INFO}/${NAME}.list
722 fi
d67004e0 723 done
dfc2b1be
DK
724}
725
726
ce9864a8 727buildaptarchivefromincoming() {
3cbbda3c 728 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
729 cd aptarchive
730 [ -e pool ] || ln -s ../incoming pool
731 [ -e ftparchive.conf ] || createaptftparchiveconfig
732 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 733 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 734 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
735 cd - > /dev/null
736 msgdone "info"
4dbfe436 737 generatereleasefiles "$@"
ce9864a8
DK
738}
739
740buildaptarchivefromfiles() {
3cbbda3c 741 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
742 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
743 msgninfo "\t${line} file… "
276e51dd 744 compressfile "$line" "$1"
8d876415 745 msgdone "info"
9b78cda6 746 done
e3c62328 747 generatereleasefiles "$@"
9b78cda6
DK
748}
749
276e51dd
DK
750compressfile() {
751 cat ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | while read compressor extension command; do
752 if [ "$compressor" = '.' ]; then
753 if [ -n "$2" ]; then
754 touch -d "$2" "$1"
755 fi
756 continue
757 fi
758 cat "$1" | $command > "${1}.${extension}"
759 if [ -n "$2" ]; then
760 touch -d "$2" "${1}.${extension}"
761 fi
762 done
763}
764
a3bbbab7 765# can be overridden by testcases for their pleasure
bf9e7447
DK
766getcodenamefromsuite() {
767 case "$1" in
768 unstable) echo 'sid';;
769 *) echo -n "$1";;
770 esac
771}
a3bbbab7 772getreleaseversionfromsuite() { true; }
718f797c 773getlabelfromsuite() { true; }
a3bbbab7 774
9b78cda6 775generatereleasefiles() {
884a4c0a
DK
776 # $1 is the Date header and $2 is the ValidUntil header to be set
777 # both should be given in notation date/touch can understand
9b78cda6
DK
778 msgninfo "\tGenerate Release files… "
779 if [ -e aptarchive/dists ]; then
780 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
a3bbbab7
DK
781 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
782 local CODENAME="$(getcodenamefromsuite $SUITE)"
783 local VERSION="$(getreleaseversionfromsuite $SUITE)"
718f797c 784 local LABEL="$(getlabelfromsuite $SUITE)"
884a4c0a 785 if [ -n "$VERSION" ]; then
718f797c
DK
786 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
787 fi
788 if [ -n "$LABEL" ]; then
789 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
a3bbbab7 790 fi
884a4c0a
DK
791 aptftparchive -qq release $dir \
792 -o APT::FTPArchive::Release::Suite="${SUITE}" \
793 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
718f797c 794 ${LABEL} \
884a4c0a
DK
795 ${VERSION} \
796 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
a3bbbab7 797 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11
DK
798 sed -i '/^Date: / a\
799NotAutomatic: yes' $dir/Release
800 fi
884a4c0a
DK
801 if [ -n "$1" -a "$1" != "now" ]; then
802 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
803 fi
804 if [ -n "$2" ]; then
805 sed -i "/^Date: / a\
806Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
807 fi
9b78cda6
DK
808 done
809 else
810 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 811 fi
884a4c0a 812 if [ -n "$1" -a "$1" != "now" ]; then
fe0f7911
DK
813 for release in $(find ./aptarchive -name 'Release'); do
814 touch -d "$1" $release
815 done
8d876415 816 fi
b7899b00 817 msgdone "info"
8d876415
DK
818}
819
b7899b00
DK
820setupdistsaptarchive() {
821 local APTARCHIVE=$(readlink -f ./aptarchive)
822 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
823 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
824 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
825 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
826 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
827 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
828 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
829 msgdone "info"
830 done
831}
832
833setupflataptarchive() {
ce9864a8 834 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
835 if [ -f ${APTARCHIVE}/Packages ]; then
836 msgninfo "\tadd deb sources.list line… "
837 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
838 msgdone "info"
839 else
840 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
841 fi
842 if [ -f ${APTARCHIVE}/Sources ]; then
843 msgninfo "\tadd deb-src sources.list line… "
844 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
845 msgdone "info"
846 else
847 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
848 fi
b7899b00
DK
849}
850
851setupaptarchive() {
4dbfe436
DK
852 local NOUPDATE=0
853 if [ "$1" = '--no-update' ]; then
854 NOUPDATE=1
855 shift
856 fi
857 buildaptarchive "$@"
b7899b00
DK
858 if [ -e aptarchive/dists ]; then
859 setupdistsaptarchive
860 else
861 setupflataptarchive
862 fi
9d653a6d 863 signreleasefiles 'Joe Sixpack'
4dbfe436 864 if [ "1" != "$NOUPDATE" ]; then
5684f71f 865 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
b2ea1a47 866 fi
8d876415
DK
867}
868
f213b6ea
DK
869signreleasefiles() {
870 local SIGNER="${1:-Joe Sixpack}"
07cb47e7 871 local REPODIR="${2:-aptarchive}"
f1e1abd8 872 local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
33a22672 873 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes"
f1e1abd8 874 msgninfo "\tSign archive with $SIGNER key $KEY… "
29a59c46
DK
875 local REXKEY='keys/rexexpired'
876 local SECEXPIREBAK="${REXKEY}.sec.bak"
877 local PUBEXPIREBAK="${REXKEY}.pub.bak"
878 if [ "${SIGNER}" = 'Rex Expired' ]; then
879 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
880 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
881 # therefore we 'temporary' make the key not expired and restore a backup after signing
882 cp ${REXKEY}.sec $SECEXPIREBAK
883 cp ${REXKEY}.pub $PUBEXPIREBAK
884 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
885 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
886 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
887 cp $SECUNEXPIRED ${REXKEY}.sec
888 cp $PUBUNEXPIRED ${REXKEY}.pub
889 else
f1e1abd8
DK
890 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
891 cat setexpire.gpg
892 exit 1
893 fi
29a59c46
DK
894 cp ${REXKEY}.sec $SECUNEXPIRED
895 cp ${REXKEY}.pub $PUBUNEXPIRED
896 fi
897 fi
07cb47e7 898 for RELEASE in $(find ${REPODIR}/ -name Release); do
29a59c46 899 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg ${RELEASE}
e3c62328 900 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
29a59c46 901 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
e3c62328
DK
902 # we might have set a specific date for the Release file, so copy it
903 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg ${INRELEASE}
f213b6ea 904 done
29a59c46
DK
905 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
906 mv -f $SECEXPIREBAK ${REXKEY}.sec
907 mv -f $PUBEXPIREBAK ${REXKEY}.pub
908 fi
f213b6ea
DK
909 msgdone "info"
910}
911
f2c0ec8b
DK
912webserverconfig() {
913 msgtest "Set webserver config option '${1}' to" "$2"
0d58c26a
DK
914 local DOWNLOG='rootdir/tmp/download-testfile.log'
915 local STATUS='rootdir/tmp/webserverconfig.status'
916 rm -f "$STATUS" "$DOWNLOG"
917 if downloadfile "http://localhost:8080/_config/set/${1}/${2}" "$STATUS" > "$DOWNLOG"; then
f2c0ec8b
DK
918 msgpass
919 else
0d58c26a
DK
920 cat "$DOWNLOG" "$STATUS"
921 msgfail
f2c0ec8b 922 fi
0d58c26a 923 testwebserverlaststatuscode '200'
f2c0ec8b
DK
924}
925
fd46d305
DK
926rewritesourceslist() {
927 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
928 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
929 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#http://localhost:4433/#${1}#"
930 done
931}
932
5572f6bd
MV
933# wait for up to 10s for a pid file to appear to avoid possible race
934# when a helper is started and dosn't write the PID quick enough
935waitforpidfile() {
936 local PIDFILE="$1"
937 for i in $(seq 10); do
938 if test -s "$PIDFILE"; then
939 return 0
940 fi
941 sleep 1
942 done
943 msgdie "waiting for $PIDFILE failed"
944 return 1
945}
946
f213b6ea 947changetowebserver() {
23af9f40
DK
948 if [ "$1" != '--no-rewrite' ]; then
949 rewritesourceslist 'http://localhost:8080/'
950 else
951 shift
952 fi
5c0dd6fc 953 if test -x ${APTWEBSERVERBINDIR}/aptwebserver; then
fbd29dd6 954 cd aptarchive
a0db467c
DK
955 local LOG="webserver.log"
956 if ! aptwebserver -o aptwebserver::fork=1 "$@" >$LOG 2>&1 ; then
bee0670b
DK
957 cat $LOG
958 false
959 fi
5572f6bd 960 waitforpidfile aptwebserver.pid
e3c62328
DK
961 local PID="$(cat aptwebserver.pid)"
962 if [ -z "$PID" ]; then
963 msgdie 'Could not fork aptwebserver successfully'
964 fi
965 addtrap "kill $PID;"
fbd29dd6 966 cd - > /dev/null
c5bcc607 967 else
fbd29dd6 968 msgdie 'You have to build aptwerbserver or install a webserver'
f213b6ea 969 fi
fd46d305
DK
970}
971
972changetohttpswebserver() {
973 if ! which stunnel4 >/dev/null; then
974 msgdie 'You need to install stunnel4 for https testcases'
975 fi
976 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
dc95fee1 977 changetowebserver --no-rewrite "$@"
fd46d305
DK
978 fi
979 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
980cert = ${TESTDIRECTORY}/apt.pem
23af9f40 981output = /dev/null
fd46d305
DK
982
983[https]
984accept = 4433
985connect = 8080
986" > ${TMPWORKINGDIRECTORY}/stunnel.conf
987 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
5572f6bd 988 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
fd46d305 989 local PID="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
5572f6bd
MV
990 if [ -z "$PID" ]; then
991 msgdie 'Could not fork stunnel4 successfully'
992 fi
fd46d305
DK
993 addtrap 'prefix' "kill ${PID};"
994 rewritesourceslist 'https://localhost:4433/'
f213b6ea
DK
995}
996
c45233ea
DK
997changetocdrom() {
998 mkdir -p rootdir/media/cdrom/.disk
999 local CD="$(readlink -f rootdir/media/cdrom)"
a0975c8d
DK
1000 echo "acquire::cdrom::mount \"${CD}\";
1001acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\";
1002acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\";
1003acquire::cdrom::autodetect 0;" > rootdir/etc/apt/apt.conf.d/00cdrom
c45233ea
DK
1004 echo -n "$1" > ${CD}/.disk/info
1005 if [ ! -d aptarchive/dists ]; then
1006 msgdie 'Flat file archive cdroms can not be created currently'
1007 return 1
1008 fi
a0975c8d 1009 mv aptarchive/dists "$CD"
c45233ea
DK
1010 ln -s "$(readlink -f ./incoming)" $CD/pool
1011 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
a0975c8d
DK
1012 # start with an unmounted disk
1013 mv "${CD}" "${CD}-unmounted"
1014 # we don't want the disk to be modifiable
1015 addtrap 'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;"
1016 chmod -R -w rootdir/media/cdrom-unmounted/dists
c45233ea
DK
1017}
1018
fd46d305 1019downloadfile() {
0d58c26a 1020 local PROTO="$(echo "$1" | cut -d':' -f 1 )"
3dcdc1f9 1021 apthelper -o Debug::Acquire::${PROTO}=1 \
0d58c26a 1022 download-file "$1" "$2" 2>&1 || true
fd46d305
DK
1023 # only if the file exists the download was successful
1024 if [ -e "$2" ]; then
1025 return 0
1026 else
1027 return 1
1028 fi
1029}
1030
f213b6ea 1031checkdiff() {
846856f4 1032 local DIFFTEXT="$(command diff -u "$@" | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
8d876415 1033 if [ -n "$DIFFTEXT" ]; then
0d58c26a
DK
1034 echo >&2
1035 echo >&2 "$DIFFTEXT"
8d876415
DK
1036 return 1
1037 else
1038 return 0
1039 fi
1040}
1041
75954ae2
DK
1042testfileequal() {
1043 local FILE="$1"
1044 shift
1045 msgtest "Test for correctness of file" "$FILE"
1046 if [ -z "$*" ]; then
f213b6ea 1047 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 1048 else
f213b6ea 1049 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
1050 fi
1051}
1052
b855a400
DK
1053testempty() {
1054 msgtest "Test for no output of" "$*"
859093da
DK
1055 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
1056 if $* >$COMPAREFILE 2>&1 && test ! -s $COMPAREFILE; then
1057 msgpass
1058 else
1059 cat $COMPAREFILE
1060 msgfail
1061 fi
b855a400
DK
1062}
1063
f74a6fa1
DK
1064testequal() {
1065 local MSG='Test of equality of'
1066 if [ "$1" = '--nomsg' ]; then
1067 MSG=''
1068 shift
1069 fi
1070
03938280 1071 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
8d876415
DK
1072 echo "$1" > $COMPAREFILE
1073 shift
d2d68aaf 1074
f74a6fa1
DK
1075 if [ -n "$MSG" ]; then
1076 msgtest "$MSG" "$*"
1077 fi
1078 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
1079}
1080
685625bd 1081testequalor2() {
03938280
DK
1082 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1083 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1084 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
685625bd
DK
1085 echo "$1" > $COMPAREFILE1
1086 echo "$2" > $COMPAREFILE2
1087 shift 2
1088 msgtest "Test for equality OR of" "$*"
18908589 1089 $* >$COMPAREAGAINST 2>&1 || true
0d58c26a
DK
1090 if checkdiff $COMPAREFILE1 $COMPAREAGAINST >/dev/null 2>&1 || \
1091 checkdiff $COMPAREFILE2 $COMPAREAGAINST >/dev/null 2>&1
1092 then
0caa5a4c
DK
1093 msgpass
1094 else
1095 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}"
1096 checkdiff $COMPAREFILE1 $COMPAREAGAINST || true
1097 echo -n "${CINFO}Diff against OR 2${CNORMAL}"
1098 checkdiff $COMPAREFILE2 $COMPAREAGAINST || true
1099 msgfail
1100 fi
685625bd
DK
1101}
1102
8d876415 1103testshowvirtual() {
edc0ef10 1104 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1105 local PACKAGE="$1"
1106 shift
1107 while [ -n "$1" ]; do
1108 VIRTUAL="${VIRTUAL}
edc0ef10 1109N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1110 PACKAGE="${PACKAGE} $1"
1111 shift
1112 done
1113 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1114 VIRTUAL="${VIRTUAL}
4bec02c2 1115N: No packages found"
03938280 1116 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
ea65d079 1117 local ARCH="$(getarchitecture 'native')"
8d876415 1118 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 1119 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
1120}
1121
1122testnopackage() {
1123 msgtest "Test for non-existent packages" "apt-cache show $*"
846856f4 1124 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
8d876415 1125 if [ -n "$SHOWPKG" ]; then
0d58c26a
DK
1126 echo >&2
1127 echo >&2 "$SHOWPKG"
8d876415 1128 msgfail
0d58c26a
DK
1129 else
1130 msgpass
8d876415 1131 fi
8d876415 1132}
01a6e24c
DK
1133
1134testdpkginstalled() {
1135 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
846856f4 1136 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep '^i' | wc -l)"
87bc1c45 1137 if [ "$PKGS" != $# ]; then
0d58c26a
DK
1138 echo >&2 $PKGS
1139 dpkg -l "$@" | grep '^[a-z]' >&2
01a6e24c 1140 msgfail
0d58c26a
DK
1141 else
1142 msgpass
01a6e24c 1143 fi
01a6e24c
DK
1144}
1145
5cf733e1
DK
1146testdpkgnotinstalled() {
1147 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
846856f4 1148 local PKGS="$(dpkg -l "$@" 2> /dev/null | grep '^i' | wc -l)"
01a6e24c
DK
1149 if [ "$PKGS" != 0 ]; then
1150 echo
0d58c26a 1151 dpkg -l "$@" | grep '^[a-z]' >&2
01a6e24c 1152 msgfail
0d58c26a
DK
1153 else
1154 msgpass
01a6e24c 1155 fi
01a6e24c 1156}
ec7f904e
DK
1157
1158testmarkedauto() {
03938280 1159 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
ec7f904e
DK
1160 if [ -n "$1" ]; then
1161 msgtest 'Test for correctly marked as auto-installed' "$*"
1162 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1163 else
1164 msgtest 'Test for correctly marked as auto-installed' 'no package'
c98fb5e0 1165 echo -n > $COMPAREFILE
ec7f904e
DK
1166 fi
1167 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1168}
89a1aa5d 1169
0440d936
DK
1170testsuccess() {
1171 if [ "$1" = '--nomsg' ]; then
1172 shift
1173 else
1174 msgtest 'Test for successful execution of' "$*"
1175 fi
03938280 1176 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
0440d936
DK
1177 if $@ >${OUTPUT} 2>&1; then
1178 msgpass
1179 else
07cb47e7 1180 local EXITCODE=$?
0d58c26a
DK
1181 echo >&2
1182 cat >&2 $OUTPUT
07cb47e7 1183 msgfail "exitcode $EXITCODE"
0440d936
DK
1184 fi
1185}
1186
1187testfailure() {
1188 if [ "$1" = '--nomsg' ]; then
1189 shift
1190 else
889b0072 1191 msgtest 'Test for failure in execution of' "$*"
0440d936 1192 fi
03938280 1193 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
0440d936 1194 if $@ >${OUTPUT} 2>&1; then
07cb47e7 1195 local EXITCODE=$?
0d58c26a
DK
1196 echo >&2
1197 cat >&2 $OUTPUT
07cb47e7 1198 msgfail "exitcode $EXITCODE"
0440d936
DK
1199 else
1200 msgpass
1201 fi
1202}
1203
5684f71f
DK
1204testaccessrights() {
1205 msgtest "Test that file $1 has access rights set to" "$2"
1206 if [ "$2" = "$(stat --format '%a' "$1")" ]; then
1207 msgpass
1208 else
1209 echo >&2
1210 ls -l >&2 "$1"
1211 echo -n >&2 "stat(1) reports access rights: "
1212 stat --format '%a' "$1"
1213 msgfail
1214 fi
1215}
1216
0d58c26a
DK
1217testwebserverlaststatuscode() {
1218 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
1219 local STATUS='rootdir/tmp/webserverstatus-statusfile.log'
1220 rm -f "$DOWNLOG" "$STATUS"
1221 msgtest 'Test last status code from the webserver was' "$1"
1222 downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG"
1223 if [ "$(cat "$STATUS")" = "$1" ]; then
1224 msgpass
1225 else
1226 echo >&2
1227 if [ -n "$2" ]; then
1228 shift
1229 echo >&2 '#### Additionally provided output files contain:'
1230 cat >&2 "$@"
1231 fi
1232 echo >&2 '#### Download log of the status code:'
1233 cat >&2 "$DOWNLOG"
1234 msgfail "Status was $(cat "$STATUS")"
1235 fi
1236}
1237
89a1aa5d
DK
1238pause() {
1239 echo "STOPPED execution. Press enter to continue"
1240 local IGNORE
1241 read IGNORE
1242}